<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTripResultInsert ArrayType
 * @subpackage Arrays
 */
class ArrayOfTripResultInsert extends AbstractStructArrayBase
{
    /**
     * The TripResultInsert
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TripResultInsert[]
     */
    public $TripResultInsert;
    /**
     * Constructor method for ArrayOfTripResultInsert
     * @uses ArrayOfTripResultInsert::setTripResultInsert()
     * @param \StructType\TripResultInsert[] $tripResultInsert
     */
    public function __construct(array $tripResultInsert = array())
    {
        $this
            ->setTripResultInsert($tripResultInsert);
    }
    /**
     * Get TripResultInsert value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TripResultInsert[]|null
     */
    public function getTripResultInsert()
    {
        return isset($this->TripResultInsert) ? $this->TripResultInsert : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTripResultInsert method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTripResultInsert method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTripResultInsertForArrayConstraintsFromSetTripResultInsert(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTripResultInsertTripResultInsertItem) {
            // validation for constraint: itemType
            if (!$arrayOfTripResultInsertTripResultInsertItem instanceof \StructType\TripResultInsert) {
                $invalidValues[] = is_object($arrayOfTripResultInsertTripResultInsertItem) ? get_class($arrayOfTripResultInsertTripResultInsertItem) : sprintf('%s(%s)', gettype($arrayOfTripResultInsertTripResultInsertItem), var_export($arrayOfTripResultInsertTripResultInsertItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TripResultInsert property can only contain items of type \StructType\TripResultInsert, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TripResultInsert value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TripResultInsert[] $tripResultInsert
     * @return \ArrayType\ArrayOfTripResultInsert
     */
    public function setTripResultInsert(array $tripResultInsert = array())
    {
        // validation for constraint: array
        if ('' !== ($tripResultInsertArrayErrorMessage = self::validateTripResultInsertForArrayConstraintsFromSetTripResultInsert($tripResultInsert))) {
            throw new \InvalidArgumentException($tripResultInsertArrayErrorMessage, __LINE__);
        }
        if (is_null($tripResultInsert) || (is_array($tripResultInsert) && empty($tripResultInsert))) {
            unset($this->TripResultInsert);
        } else {
            $this->TripResultInsert = $tripResultInsert;
        }
        return $this;
    }
    /**
     * Add item to TripResultInsert value
     * @throws \InvalidArgumentException
     * @param \StructType\TripResultInsert $item
     * @return \ArrayType\ArrayOfTripResultInsert
     */
    public function addToTripResultInsert(\StructType\TripResultInsert $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TripResultInsert) {
            throw new \InvalidArgumentException(sprintf('The TripResultInsert property can only contain items of type \StructType\TripResultInsert, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TripResultInsert[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TripResultInsert|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TripResultInsert|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TripResultInsert|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TripResultInsert|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TripResultInsert|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TripResultInsert
     */
    public function getAttributeName()
    {
        return 'TripResultInsert';
    }
}
